get_digit:
	movslq	%esi, %rsi
	movl	(%rdi,%rsi,4), %eax
	ret

get_uky_zip:
	movslq	%edi, %rdi           // sign-extend index to 64 bits
	leaq	(%rdi,%rdi,4), %rax  // rax = 5 * index

	/* These next two could also be   leaq uky(,%rax,4), %rax */
	salq	$2, %rax             // rax <<= 2;  (20 * index)
	addq	$uky, %rax           // uky + 20*index  ==  &uky[index]
	ret

get_uky_digit:
	/* %edi = index, %esi = digit */
	movslq	%esi, %rsi           // sign-extend digit to 64 bits
	movslq	%edi, %rdi           // sign-extend index to 64 bits
	leaq	(%rdi,%rdi,4), %rax  // rax = 5*index
	addq	%rax, %rsi           // rax = 5*index + digit
	movl	uky(,%rsi,4), %eax   // retval = *(uky + 4 * (5*index + digit))
	ret

.LC0:
	.string	"Last two digits: %d%d\n"

main:
	pushq	%rbp
	pushq	%rbx
	subq	$8, %rsp
	movl	$0, %edi
	call	get_uky_zip
	movq	%rax, %rbp
	movl	$4, %esi
	movl	$0, %edi
	call	get_uky_digit
	movl	%eax, %ebx
	movl	$3, %esi
	movq	%rbp, %rdi
	call	get_digit
	movl	%ebx, %ecx
	movl	%eax, %edx
	movl	$.LC0, %esi
	movl	$1, %edi
	movl	$0, %eax
	call	__printf_chk
	movl	$0, %eax
	addq	$8, %rsp
	popq	%rbx
	popq	%rbp
	ret

	.size	main, .-main
	.globl	uky
	.data
	.align 32
	.type	uky, @object
	.size	uky, 80
uky:
	/* 20 entries of 4 bytes each.  The memory layout doesn't distinguish
	 * the end of one row from the beginning of the next */
	.long	4 // row 0
	.long	0
	.long	5
	.long	0
	.long	6
	.long	4 // row 1
	.long	0
	.long	5
	.long	2
	.long	6
	.long	4 // row 2
	.long	0
	.long	5
	.long	3
	.long	6
	.long	4 // row 3
	.long	0
	.long	5
	.long	4
	.long	6
