get_univ_digit:
	/* %rdi = index, %rsi = digit */
	salq	$2, %rsi            // sizeof(int) * digit;

	/* 8 here is sizeof(int *) */
	/* Memory access! */
	addq	univ(,%rdi,8), %rsi // p = *(univ + 8*index) + 4*digit

	/* Memory access! */
	movl	(%rsi), %eax        // retval = *p
	ret

.LC0:
	.string	"UKY first digit = %d\n"
main:
	subq	$8, %rsp
	movl	$0, %esi
	movl	$1, %edi
	call	get_univ_digit
	movl	%eax, %edx
	movl	$.LC0, %esi
	movl	$1, %edi
	movl	$0, %eax
	call	__printf_chk
	movl	$0, %eax
	addq	$8, %rsp
	ret

	/* An array of three pointers, so size 24 */
	.globl	univ
	.data
	.align 16
	.type	univ, @object
	.size	univ, 24
univ:
	.quad	mit  // 8 bits, value (address) of mit
	.quad	uky  // 8 bits, value (address) of uky
	.quad	ucb  // 8 bits, value (address) of ucb

	/* The three arrays pointed to */
	.globl	ucb
	.align 16
	.type	ucb, @object
	.size	ucb, 20
ucb:
	.long	9
	.long	4
	.long	7
	.long	2
	.long	0

	.globl	mit
	.align 16
	.type	mit, @object
	.size	mit, 20
mit:
	.long	0
	.long	2
	.long	1
	.long	3
	.long	9

	.globl	uky
	.align 16
	.type	uky, @object
	.size	uky, 20
uky:
	.long	4
	.long	0
	.long	5
	.long	0
	.long	8
