get_digit:
	/* %esi and %eax are the 32-bit versions of %rsi and %rax */

	movslq	%esi, %rsi            // sign-extend digit from 32 to 64 bits 
	/* The 4 here (scale) is sizeof(int) */
	movl	(%rdi,%rsi,4), %eax   // retval = *(z + digit);
	ret


zincr:
	movl	$0, %eax          // i = 0
	jmp	.L3               // jump to middle (while loop condition)
	/* body of for loop */
.L4:
	addl	$1, (%rdi,%rax,4) // *(z + i)++

	/* update expression of for loop */
	addq	$1, %rax          // i++

	/* condition of for loop */
.L3:
	cmpq	$4, %rax          // compare i and 4
	jbe	.L4               // if i <= 4 (if i < 5), repeat

	rep ret

.LC0:
	.string	"UKY first digit = %d\n"
.LC1:
	.string	"After zincr it is %d\n"

main:
	subq	$8, %rsp

	movl	$0, %esi
	movl	$uky, %edi
	call	get_digit

	movl	%eax, %edx
	movl	$.LC0, %esi
	movl	$1, %edi
	movl	$0, %eax
	call	__printf_chk

	movl	$uky, %edi
	call	zincr

	movl	$0, %esi
	movl	$uky, %edi
	call	get_digit

	movl	%eax, %edx
	movl	$.LC1, %esi
	movl	$1, %edi
	movl	$0, %eax
	call	__printf_chk

	movl	$0, %eax
	addq	$8, %rsp
	ret

/* ucb is a global variable, in the 'data' section of the executable.
 * It will be aligned to a multiple of 16 bytes, and is 20 bytes long.
 */
	.globl	ucb
	.data /* subsequent instructions and data go to the data section */
	.align 16
	.type	ucb, @object
	.size	ucb, 20
/* here are the 20 bytes of UCB, as 5 32-bit values */
ucb:
	.long	9
	.long	4
	.long	7
	.long	2
	.long	0

/* Likewise for mit */
	.globl	mit
	.align 16
	.type	mit, @object
	.size	mit, 20
mit:
	.long	0
	.long	2
	.long	1
	.long	3
	.long	9

/* And uky */
	.globl	uky
	.align 16
	.type	uky, @object
	.size	uky, 20
uky:
	.long	4
	.long	0
	.long	5
	.long	0
	.long	8
	.ident	"GCC: (Ubuntu 4.8.4-2ubuntu1~14.04) 4.8.4"
	.section	.note.GNU-stack,"",@progbits
